#include "../../particles.lua"

local range = 20
local killRange = 1
local power = 500
local maxPower = 3
local active = true
local activeTime = 6
local activeTimeLeft = activeTime

function init()
    self = FindLocation("hole")
    sprite = LoadSprite("MOD/dropItems/blackhole/blackhole.png")
end
function update()
    if active == false then return end
    local transform = GetLocationTransform(self)
    force360(transform.pos, 2, range, 1)
end
function tick(dt)
    if active == false then return end

    --Draw sprite
    local transform = GetLocationTransform(self)
    transform.rot = QuatLookAt(transform.pos, GetCameraTransform().pos)
    DrawSprite(sprite, transform, 1, 1, 1, 1, 1, 1, true, false)

    --Find no drop effects
    local luckyblocks = FindBodies("nodropeffect", true)

    --Destroy objects too close
    for x=1, #luckyblocks do
        QueryRejectBody(luckyblocks[x])
    end
    local delObjects = getObjects_location(transform.pos, killRange)
    for x=1, #delObjects do
        Delete(delObjects[x])
    end

    --Pull objects
    for x=1, #luckyblocks do
        QueryRejectBody(luckyblocks[x])
    end
    local pullObjects = getObjects_location(transform.pos, range)
    for x=1, #pullObjects do
        local tPos = getBodyPos(pullObjects[x])
        local dist = getDist(tPos, transform.pos)
        local mass = GetBodyMass(pullObjects[x])
        local dir = VecScale(VecNormalize(VecSub(tPos, transform.pos)), -math.min(math.max(range-dist, 0)*power/mass, maxPower))
        local vel = GetBodyVelocity(pullObjects[x])
        SetBodyVelocity(pullObjects[x], VecAdd(dir, vel))
    end

    --Break static
    local breakDir = randVec(-1, 1, 4)
    QueryRequire("physical")
    local hit, dist = QueryRaycast(transform.pos, breakDir, range, 0, false)
    if hit then
        local newPos = VecAdd(VecScale(breakDir, dist), transform.pos)
        MakeHole(newPos, 2, 1, 0)
    end

    --Pass time and disable when time runs out
    activeTimeLeft = activeTimeLeft - dt
    if activeTimeLeft <= 0 then 
        force360(transform.pos, -8, killRange, 30, 1)
        active = false
    end
end