#include "../../particles.lua"
#include "../../dropFunctions.lua"

function drop(self)
    --VARIABLES
    local selfPos = GetBodyTransform(self).pos
    local shouldSleep = false

    local drops = {
        --Explosion
        [0] = function()
            Explosion(selfPos, math.random(0, 6))
            shouldSleep = true
        end,
        --Air strike
        [1] = function()
            Shoot(VecAdd(selfPos, Vec(0, 20, 0)), Vec(0, -1, 0), "rocket")
            shouldSleep = true
        end,
        --Bounce
        [2] = function()
            SetBodyVelocity(self, Vec(math.random(-25, 25), 8, math.random(-25, 25)))
            PlaySound(LoadSound("MOD/snd/abilities/bounce.ogg"), selfPos, 2)
        end,
        --Spawns balloon lucky block
        [3] = function()
            Spawn("MOD/luckyblocks/balloon/block.xml", Transform(VecAdd(selfPos, Vec(0, 0.5, 0))))
            shouldSleep = true
        end,
        --Pushes things
        [4] = function()
            local value = math.random(10, 25)
            push(self, 15, value)
            force360(selfPos, -value*2, 1, 30)
            shouldSleep = true
        end,
        --Pulls things
        [5] = function()
            local value = -math.random(10, 25)
            push(self, 15, value)
            force360(selfPos, -value/8, 15, 30)
            shouldSleep = true
        end,
        --Spawns an anvil
        [6] = function()
            Spawn("MOD/dropItems/anvil.xml", Transform(VecAdd(selfPos, Vec(0, 20, 0))))
            shouldSleep = true
        end,
        --Spawns a cake
        [7] = function()
            Spawn("MOD/dropItems/cake.xml", Transform(selfPos))
            shouldSleep = true
        end,
        --Shoots fire out of the lucky block
        [8] = function()
            napalm(self, 10, 150, 6)
            shouldSleep = true
        end,
        --Flings every object into a different random direction
        [9] = function()
            flingAll(self, 10, math.random(15, 30))
            shouldSleep = true
        end,
        --Flings every object into a random direction
        [10] = function()
            fling(self, 10, math.random(15, 30))
            shouldSleep = true
        end,
        --Shoots bullets in every direction
        [11] = function()
            shootAround(self, 50, "gun")
            shouldSleep = true
        end,
        --Shoots rockets in every direction
        [12] = function()
            shootAround(self, 50, "rocket")
            shouldSleep = true
        end,
        --Shatter
        [13] = function()
            for x=1, 5 do
                MakeHole(selfPos, 4, 4, 4)
            end
            shouldSleep = true
        end,
        --Car
        [14] = function()
            Spawn("MOD/dropItems/luckycar/luckycar.xml", Transform(selfPos, QuatEuler(0, math.random(0, 360))))
            shouldSleep = true
        end,
        --Spawns an explosive
        [15] = function()
            Spawn("MOD/dropItems/explosive.xml", Transform(selfPos))
            shouldSleep = true
        end,
        --Spawns a black hole
        [16] = function()
            Spawn("MOD/dropItems/blackhole/blackhole.xml", Transform(selfPos))
            shouldSleep = true
        end,
    }
    
    --ROLL
    luckVal = math.random(0, #drops)

    --GET DROP
    drops[luckVal]()

    return shouldSleep
end